#
# The Zope Irc Bot
#
# (The Stupidest Zope Product Ever Written)
#
# (C) Copyright 2000 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

import App, Globals, OFS
import string
import time

from popen2 import popen3

from Persistence import Persistent
from Globals import ImageFile, HTMLFile, HTML, MessageDialog, package_home
from Acquisition import Implicit
from OFS.Folder import Folder
from App.Extensions import getObject
from webdav.NullResource import NullResource
from ZPublisher.HTTPResponse import HTTPResponse

from Products.IrcBot.Plugins.Plugins import Plugin, PluginRegister
from Products.IrcBot.IrcChannel import IrcChannel

def manage_addOpPlugin(self, id, opString, opLevel, autoOpLevel, REQUEST={}):
	""" Add a generic 'op' Plugin """

	obj = OpPlugin(id=id, opString=opString)
	self._setObject(id, obj)
	obj=getattr(self, id)
	obj.setAutoOpLevel(autoOpLevel)
	obj.setOpLevel(opLevel)
	obj.registerBotAction()
	self._p_changed=1
	if REQUEST:
		return self.manage_main(self, REQUEST)
	return ''
			

manage_addOpPluginForm=HTMLFile('manage_addOpPluginForm', globals())

class OpPlugin(Plugin):
	# We set most of the individual items from manage_add...

	meta_type='Chanop Plugin'

	manage_configurePluginForm=HTMLFile('manage_configureOpPluginForm', globals())
	
	def __init__(self, id, opString):
		self.id=id
		self.opString=opString
		self.opLevel=1000000
		self.autoOpLevel=1000000

	def manage_configureOpPlugin(self, opString, opLevel, autoOpLevel,
								 REQUEST={}):
		""" Change the Settings for Ops """
		self.deregisterBotAction()
		self.opString=opString
		self.registerBotAction()
		self.setAutoOpLevel(autoOpLevel)
		self.setOpLevel(opLevel)
		if REQUEST:
			return self.manage_configureOpPluginForm(self, REQUEST)
		return ''
		
	def setAutoOpLevel(self, level):
		self.autoOpLevel=int(level)

	def setOpLevel(self, level):
		self.opLevel=int(level)

	def opUser(self, nick):
		self.ThreadMethods.addCommand(['MODE', self.channel, '+o', nick], None)
		
	def do_join(self, sender, recip, forum, addl, raw):
		op, args, text = raw
		if self.autoOpLevel and (self.ThreadMethods.findUserLevel(raw) < self.autoOpLevel):
			# Access level too low, or not registered
			return
		hostmask=args[0]
		nick,hostmask=string.split(hostmask,'!')
		self.opUser(nick)

	bot_action = do_join

	def do_op(self, sender, recip, forum, addl, raw):
		# Don't listen to public traffic
		if forum is not sender:
			return
		op, args, text = raw
		if self.opLevel and (self.ThreadMethods.findUserLevel(raw) < self.opLevel):
			# Access level too low, or not registered
			return
		hostmask=args[0]
		nick,hostmask=string.split(hostmask,'!')
		self.opUser(nick)
		
	def registerBotAction(self):
		# Handle requests for ops
		self.ThreadMethods.addCommand(['BIND', 'PRIVMSG', self.do_op], self.opString)
		# Handle auto-ops
		self.ThreadMethods.addCommand(['BIND', 'JOIN', self.do_join])

OpRegister=PluginRegister('Op', 'Op Users', OpPlugin,
						  manage_addOpPluginForm, manage_addOpPlugin)

IrcChannel.Plugins['Op']=OpRegister
