#
# The Zope Irc Bot
#
# (The Stupidest Zope Product Ever Written)
#
# (C) Copyright 2000 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

import App, Globals, OFS
import string
import time

from Globals import ImageFile, HTMLFile, HTML, MessageDialog, package_home
from OFS.Folder import Folder

NotImplemented="Required Method Not Implemented"

#
# This is a folder object, so that you can implement
# Plugins using DTML methods if you want to, just drop
# them in...
#

class Plugin(Folder):
	""" Class for representing Bot Plugins """

	icon="misc_/IrcBot/IrcBotPlugin.gif"
	meta_type="Zope Bot Plugin"

	PluginName="NoName"
	PluginDescription="No Description"

	manage_configurePluginForm=HTMLFile('manage_configurePluginForm',globals())

	manage_options=(
		{'label':'Configure Plugin', 'action':'manage_configurePluginForm'},
		)

	# We remove ourselves from the bot, if someone deletes us from the
	# Web Interface...
	def manage_beforeDelete(self, item, container):
		self.deregisterBotAction()
		
	def bot_action(self, sender, recip, forum, addl, raw):
		raise NotImplemented

	def registerBotAction(self):
		raise NotImplemented

	def deregisterBotAction(self):
		raise NotImplemented

	def manage_configurePlugin(self, REQUEST={}):
		""" Implement me to configure your plugin """
		raise NotImplemented
	
	def enableBotAction(self):
		self.enabled=1
		self.registerBotAction()

	def disableBotAction(self):
		self.enabled=0
		self.deregisterBotAction()


#
# The IrcChannel keeps a list of available plugins
# The User chooses which plugins to enable and disable.
#
# If the user wants to start a Plugin, your 'form' is displayed so
# that you can gather your required parameters and add a new Plugin

class PluginRegister:
	def __init__(self, name, description, pluginClass,
				 pluginStartForm, pluginStartMethod):
		self.name=name #No Spaces please...
		self.description=description
		self.plugin=pluginClass
		self.manage_addPluginForm=pluginStartForm
		self.manage_addPlugin=pluginStartMethod

