#
# The Zope Irc Bot
#
# (The Stupidest Zope Product Ever Written)
#
# (C) Copyright 2000 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>

import App, Globals, OFS
import string
import time

from popen2 import popen3

from Persistence import Persistent
from Globals import ImageFile, HTMLFile, HTML, MessageDialog, package_home
from Acquisition import Implicit
from OFS.Folder import Folder
from OFS.SimpleItem import SimpleItem
from App.Extensions import getObject
from webdav.NullResource import NullResource
from ZPublisher.HTTPResponse import HTTPResponse

from Products.IrcBot.Plugins.Plugins import Plugin, PluginRegister
from Products.IrcBot.IrcChannel import IrcChannel


def manage_addUserStuffPlugin(self, REQUEST={}):
	""" Add the ability for users to make comments about themselves """
	obj=UserStuffPlugin('UserPlugin')
	self._setObject('UserPlugin', obj)
	obj=getattr(self, 'UserPlugin')
	obj.registerBotAction()
	
	if REQUEST:
		return self.manage_main(self, REQUEST)
	return ''

manage_addUserStuffPluginForm=HTMLFile('manage_addUserPluginForm', globals())

class UserStuffPlugin(Plugin):

	meta_type='User Info Plugin'
	
	def __init__(self, id):
		self.id = id
		self.title='User Information Plugin'

	def registerBotAction(self):
		self.ThreadMethods.addCommand(['BIND', 'PRIVMSG', self.do_whois], '^whois:')
		self.ThreadMethods.addCommand(['BIND', 'PRIVMSG', self.add_comment], '^mycomment:')
		self.ThreadMethods.addCommand(['BIND', 'PRIVMSG', self.add_url], '^myurl:')				
	def deregisterBotAction(self):
		self.ThreadMethods.addCommand(['UNBIND', 'PRIVMSG', self.do_whois], '^whois:')
		self.ThreadMethods.addCommand(['UNBIND', 'PRIVMSG', self.add_comment], '^mycomment:')				
		self.ThreadMethods.addCommand(['UNBIND', 'PRIVMSG', self.add_url], '^myurl:')		
	def do_whois(self, sender, recip, forum, addl, raw):
		command, args, text=raw
		text=string.strip(text[6:])
		if not text:
			return
		u= self.getIrcUserObject(text)
		if not u:
			sender.tell("No such user: %s"%(text))
			return
		if u.hasProperty('comment'):
			forum.tell('%s says: %s'%(text,u.getProperty('comment')))
		if u.hasProperty('url'):
			forum.tell('%s is at: %s'%(text, u.getProperty('url')))

	# Allow a user to add a comment
	# mycomment: blah blah blah
	def add_comment(self, sender, recip, forum, addl, raw):
		if forum is not sender:
			return
		op, args, text = raw

		text=string.strip(text[10:])
		user = self.ThreadMethods.findUser(raw)
		if not user:
			sender.tell("Naughty naughty!")
			return
		user.setProperty('comment',text)
		sender.tell('comment %s set'%(text))

	# Allow a user to add a url
	# myurl: http://foo.bar.com/
	def add_url(self, sender, recip, forum, addl, raw):
		if forum is not sender:
			return
		op, args, text = raw

		text=string.strip(text[6:])
		user = self.ThreadMethods.findUser(raw)
		if not user:
			sender.tell("Naughty naughty!")
			return
		user.setProperty('url',text)
		sender.tell('url %s set'%(text))		

		
UserStuffRegister=PluginRegister('UserStuff', 'Users Info', UserStuffPlugin,
						  manage_addUserStuffPluginForm, manage_addUserStuffPlugin)

IrcChannel.Plugins['UserStuff']=UserStuffRegister
