#
# The Zope Irc Bot
#
# (The Stupidest Zope Product Ever Written)
#
# (C) Copyright 2000 The Internet (Aust) Pty Ltd
# ACN: 082 081 472  ABN: 83 082 081 472
# All Rights Reserved
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# Author: Andrew Milton <akm@theinternet.com.au>


from ImageFile import ImageFile
from threading import Thread
import IrcChannel
import IRCRegistrar
import IrcBot
import Plugins

RegistryId=IRCRegistrar.RegistryId
RegistryChange=IRCRegistrar.RegistryChange

misc_ = {
	'IrcRegistrar.gif': ImageFile('IrcRegistrar.gif', globals()),
	'IrcBotPlugin.gif': ImageFile('IrcBotPlugin.gif', globals()),
	'IrcUser.gif': ImageFile('IrcUser.gif', globals()),	
	}

def initialize(context):

	try:
		context.registerClass(
			IrcChannel.IrcChannel,
			meta_type='IRC Channel',
			icon='IrcChannel.gif',
			permission='Add Irc Channel',
			constructors=(IrcChannel.manage_addIrcChannelForm,
						  IrcChannel.manage_addIrcChannel),
			)
	except:
		print "I knew that would happen..."
		import traceback
		traceback.print_exc()

	

	try:
		app = context._ProductContext__app

		global IRCRegistry
		if hasattr(app, RegistryId):
			IRCRegistry = getattr(app, RegistryId, None)
		else:
			try:
				obj = IRCRegistrar.IRCRegistrar(id=RegistryId, title='IRC Bot Registrar')
				app._setObject(RegistryId, obj)
				get_transaction().note('Added IRC Bot Registry %s'%(RegistryId))
				get_transaction().commit()
			except:
				pass
			IRCRegistry = getattr(app, RegistryId, None)

		assert IRCRegistry is not None

		# Go find the registered class channels and
		# rebuild our internal index of classes.

		IRCRegistry.wakeupChannels()

		dispatcher = Thread(target = IrcBot.ZopeBot.BotRunner,
							name='IRC Bot Runner',
							args=(RegistryId, RegistryChange))

		dispatcher.setDaemon(1)
		dispatcher.start()

	except:
		print "Oh no not again!"
		import traceback
		traceback.print_exc()
